# all files / ol/ image.js

76.92% Statements 40/52
50% Branches 7/14
85.71% Functions 6/7
76.92% Lines 40/52

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    1611×

    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×

    71×

    71×

    71×
    71×
    6×

    71×

    71×

    71×

    71×

    1×

    1×
    127×

    127×

    1×

    1×
    34×
    31×

    34×
    34×
    34×

    1×
    39×
    39×
    39×
    39×

    39×

    1×
    3×

    1×
    34×
    34×

     goog.provide('ol.Image');

    goog.require('ol');
    goog.require('ol.ImageBase');
    goog.require('ol.ImageState');
    goog.require('ol.events');
    goog.require('ol.events.EventType');
    goog.require('ol.extent');
    goog.require('ol.obj');

    /**
     * @constructor
     * @extends {ol.ImageBase}
     * @param {ol.Extent} extent Extent.
     * @param {number|undefined} resolution Resolution.
     * @param {number} pixelRatio Pixel ratio.
     * @param {Array.<ol.Attribution>} attributions Attributions.
     * @param {string} src Image source URI.
     * @param {?string} crossOrigin Cross origin.
     * @param {ol.ImageLoadFunctionType} imageLoadFunction Image load function.
     */
    ol.Image = function(extent, resolution, pixelRatio, attributions, src,
        crossOrigin, imageLoadFunction) {

      ol.ImageBase.call(this, extent, resolution, pixelRatio, ol.ImageState.IDLE,
          attributions);

      /**
       * @private
       * @type {string}
       */
      this.src_ = src;

      /**
       * @private
       * @type {HTMLCanvasElement|Image|HTMLVideoElement}
       */
      this.image_ = new Image();
      if (crossOrigin !== null) {
        this.image_.crossOrigin = crossOrigin;
      }

      /**
       * @private
       * @type {Object.<number, (HTMLCanvasElement|Image|HTMLVideoElement)>}
       */
      this.imageByContext_ = {};

      /**
       * @private
       * @type {Array.<ol.EventsKey>}
       */
      this.imageListenerKeys_ = null;

      /**
       * @protected
       * @type {ol.ImageState}
       */
      this.state = ol.ImageState.IDLE;

      /**
       * @private
       * @type {ol.ImageLoadFunctionType}
       */
      this.imageLoadFunction_ = imageLoadFunction;

    };
    ol.inherits(ol.Image, ol.ImageBase);

    /**
     * @inheritDoc
     * @api
     */
    ol.Image.prototype.getImage = function(opt_context) {
      Iif (opt_context !== undefined) {
        var image;
        var key = ol.getUid(opt_context);
        if (key in this.imageByContext_) {
          return this.imageByContext_[key];
        } else if (ol.obj.isEmpty(this.imageByContext_)) {
          image = this.image_;
        } else {
          image = /** @type {Image} */ (this.image_.cloneNode(false));
        }
        this.imageByContext_[key] = image;
        return image;
      } else {
        return this.image_;
      }
    };

    /**
     * Tracks loading or read errors.
     *
     * @private
     */
    ol.Image.prototype.handleImageError_ = function() {
      this.state = ol.ImageState.ERROR;
      this.unlistenImage_();
      this.changed();
    };

    /**
     * Tracks successful image load.
     *
     * @private
     */
    ol.Image.prototype.handleImageLoad_ = function() {
      if (this.resolution === undefined) {
        this.resolution = ol.extent.getHeight(this.extent) / this.image_.height;
      }
      this.state = ol.ImageState.LOADED;
      this.unlistenImage_();
      this.changed();
    };

    /**
     * Load the image or retry if loading previously failed.
     * Loading is taken care of by the tile queue, and calling this method is
     * only needed for preloading or for reloading in case of an error.
     * @override
     * @api
     */
    ol.Image.prototype.load = function() {
      Eif (this.state == ol.ImageState.IDLE || this.state == ol.ImageState.ERROR) {
        this.state = ol.ImageState.LOADING;
        this.changed();
        this.imageListenerKeys_ = [
          ol.events.listenOnce(this.image_, ol.events.EventType.ERROR,
              this.handleImageError_, this),
          ol.events.listenOnce(this.image_, ol.events.EventType.LOAD,
              this.handleImageLoad_, this)
        ];
        this.imageLoadFunction_(this, this.src_);
      }
    };

    /**
     * @param {HTMLCanvasElement|Image|HTMLVideoElement} image Image.
     */
    ol.Image.prototype.setImage = function(image) {
      this.image_ = image;
    };

    /**
     * Discards event handlers which listen for load completion or errors.
     *
     * @private
     */
    ol.Image.prototype.unlistenImage_ = function() {
      this.imageListenerKeys_.forEach(ol.events.unlistenByKey);
      this.imageListenerKeys_ = null;
    };